<?php
#-----------------------------------------------------------------------
# display source of script if requested so
#-----------------------------------------------------------------------
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
}
#-----------------------------------------------------------------------
# just to know which script version is executing
#-----------------------------------------------------------------------
$pageName	= 'wsMenuLoad.php';
if (!isset($SITE)){echo "<h3>invalid call to script $pageName</h3>";exit;}
$pageVersion	= '3.01special 2014-10-23';
$SITE['wsModules'][$pageName] = 'version: ' . $pageVersion;
$pageFile = basename(__FILE__);			// check to see this is the real script
if ($pageFile <> $pageName) {$SITE['wsModules'][$pageFile]	= 'this file loaded instead of '.$pageName;}
$pathString .= '<!-- module '.$pageFile.' ==== '.$SITE['wsModules'][$pageFile]." -->".PHP_EOL;
#-----------------------------------------------------------------------------------------
# 3.00 2014-09-29 release version	
# 3.01 2014-10-04 -03 code for rare (old) error in php xml implementation  - lines 70-76 -04 EWN problem disappearing menu
# 3.01special 2014-10-23  test new updated images in menu
#-----------------------------------------------------------------------------------------
$menuArray	= array();				// array with all possible menuchoices
$menuData	= $SITE['menuXml'];			// here we find the xml file					
$string 	= file_get_contents($menuData);  	// load menu xml file into string
$xmlStr 	= new SimpleXMLElement($string);	// make xml object
#
$pageFile	= $menuData;
$pageVersion= (string)$xmlStr->dateVersion;
$SITE['wsModules'][$menuData] = 'version: '.(string)$xmlStr->dateVersion;  // save some info
$pathString .= '<!-- module '.$pageFile.' ==== '.$SITE['wsModules'][$pageFile]." -->".PHP_EOL;
#
$level		= 1;								//number of LI tabs to have clean looking output
wsMenuGen 	($xmlStr);							// iterative routine to create main li's en lower level  ul/li's
#unset 		($xmlStr);							// get rid of the xml
#return;
#
#--------------------------------------------------------------------------------------------------
#  iterative fuction to generate li and ul/li; when the array with menuchoices etc is build
#--------------------------------------------------------------------------------------------------
function wsMenuGen ($data) {								
	global $DropdownMenuText, $level, $SITE, $menuArray, $extraP, $lang, $pathString;	
	foreach ($data->item as $menuItem) {
		$Show= true;			// default every xml-menu setting is shown
		if (isset($menuItem['show'])) {
# show can be (1) 'yes/'no' or (2) true/false or (3) a reference to a $SITE setting which can be  (1) 'yes/'no' or (2) true/false (3)
			if ($menuItem['show'] == false) {
				continue;
			} 
			if  (trim($menuItem['show']) == 'no') {
				continue;
			}
			$string = strval($menuItem['show']);
			if (isset($SITE[$string])) {
					if ($SITE[$string] === false || $SITE[$string] === 'no') {continue;}
			}  // eo check sitestring
		}  // eo check if this menu item be shown to the visitor
#
		for ($i=1 ; $i <= $level ; $i++) {$DropdownMenuText.="\t";}   	// number of tabs
		if (isset ($SITE['skipTop']) && $SITE['skipTop']) 
		        {$top = '#data-area';}
		else    {$top = '';}
		if (isset ($menuItem['top']) ) {
		        $string = trim($menuItem['top']);
		        if ($menuItem['top'] == false) 
		                {$top = '';} 
		        elseif ($string == 'no') 
		                {$top = '';}
		        else    {$top    = '#'.$string;}
		}
		if (!isset ($menuItem['title']) ) {
		        $menuTitle = $menuItem['caption'];
		} else {
		        $menuTitle = $menuItem['title'];
		}
		$img    = '';
		if (isset($menuItem['img']) ){
		        $img    = trim((string) $menuItem['img']);
		        if ($img  == 'updated') {$img= 'img/menu_updated.gif';}
		        elseif ($img  == 'new') {$img= 'img/menu_new.gif';}
		        $img = ' <img src ="'.$img.'" alt=" ">';
		}	
		if (!isset($menuItem['link'])) {								// submenuheaders have no link specified
			$DropdownMenuText.=
			'<li class="withImg">
			<a href="#" title="'.langtransstr($menuTitle).'">'.
			langtransstr($menuItem['caption']).$img.
			'</a>'.PHP_EOL;
			for ($i=1 ; $i <= $level ; $i++) {$DropdownMenuText.='	';} // number of tabs
			$DropdownMenuText.='	<ul>'.PHP_EOL;						// new ul group
			$level= $level + 1;											// extra tab in new level
			$data2 = $menuItem;											// 
				wsMenuGen ($data2);    	// this function calls itself for nested menu levels
			for ($i=1 ; $i <= $level ; $i++) {$DropdownMenuText.='	';}
			$DropdownMenuText.='</ul>'.PHP_EOL;								// end new ul group
			$level = $level - 1;										// back 1 level
			for ($i=1 ; $i <= $level ; $i++) {$DropdownMenuText.='	';}
			$DropdownMenuText.='</li>'.PHP_EOL;
		} else {
			$nr = (string) $menuItem['nr'];
			if ($SITE['noChoice'] == $nr) 	{$top = '';}
			$menuArray[$nr]['choice']		=trim((string) $menuItem['nr']);
			$menuArray[$nr]['css']  		=trim((string) $menuItem['css']);
			$menuArray[$nr]['head']  		=trim((string) $menuItem['head']);
			$menuArray[$nr]['show']  		=trim((string) $menuItem['show']);
			$tekst = trim((string) $menuItem['folder']);
			if ($tekst == '') {
				$menuArray[$nr]['folder']	= '';
			} else {
				$menuArray[$nr]['folder']	= $tekst;
			}
			$tekst = trim((string) $menuItem['gizmo']);
			if ($tekst == '' || $tekst == '0' || $tekst == 'no' || $tekst == 'false' ) {
				$menuArray[$nr]['gizmo']	= false;
			} else {
				$menuArray[$nr]['gizmo']	= true;			
			}
			$menuArray[$nr]['link']			=trim((string) $menuItem['link']);
			$menuArray[$nr]['noutf8']		=trim((string) $menuItem['noutf8']);
			$menuArray[$nr]['title']		=trim((string) $menuTitle);
			$DropdownMenuText.='<li><a href="index.php?p='.$nr.'&amp;lang='.$lang.$extraP.$top.'" title="'.langtransstr($menuTitle).'">'.langtransstr($menuItem['caption']).$img.'</a></li>'.PHP_EOL;	
		} // eof link aanwezig of niveau dieper
	}// eof foreach
} // eof function
?>
